Redmine - Patch #2010

Wiki Sidebar: Adding a (navigational / TOC) section
2008-10-08 22:37 - Christian Zuckschwerdt

Status: Closed Start date: 2008-10-08
Priority: Normal Due date:

Assignee: % Done: 30%
Category: Wiki Estimated time: 0.00 hour
Target version:

Description

It would be nice if we could show a special page (if available) in the Wiki Sidebar section.
That way projects can display a list of hot links, a custom TOC or other infos on all wiki pages.
Maybe this can be generalized for other areas of redmine too.

Attached is a simple concept patch for r1928.

Related issues:
Related to Redmine - Feature #5208: Aibility to edit wiki sidebar Closed

2010-03-29

History

#1 - 2008-10-08 22:38 - Christian Zuckschwerdt

Sorry. This is not a defect. Is it possible to change this to "Feature Request"?

#2 - 2008-10-16 21:10 - Jean-Philippe Lang

- Tracker changed from Defect to Patch

#3 - 2009-01-28 11:59 - Ben Blanco
- File trac.png added
- File redmine.png added

Hi Christian,

We're looking for the same feature/functionality. We switched over to redmine from trac where we used the TocMacro plugin.

It's really nice to have a native built-in TOC feature in redmine wiki pages - as well as the ability to have parent/child crumbs.

However, our users still get lost and are asking for easier navigation - ie. like we have before. Thus we'd like to be able to reinstate a global TOC for

our projects' wikis in redmine. The TOC in trac was easy to edit, ie. just another wiki page using same wiki syntax -> it would be ideal to have

something equally as simple in redmine, with added difference of being able to also list redmine default wiki views:

e [ndex by title
¢ Index by date

Here is what we had:
https://www.redmine.org/projects/redmine/repository/svn/revisions/1928
http://www.redmine.org
http://trac.edgewall.org/
http://trac-hacks.org/wiki/TocMacro
Home
Getting Started
What is askiavista?
Support
Minimum requirements
Install
Update 5.2.4.0
Upgrade 5.1.6.x to 5.2.4.0
Internet Explorer 6 settings
Internet Explorer 7 settings
Development
Version history
AskiaVista SDK
API Code examples
API Code examples - scripts

Welcome to AskiaVista Wiki Trac

Hi, we've made this wiki for you!

We do our best to keep it up to date as well as 100% accurate, but in case you do notice something please contact us!
I. Install

If you want to install askiavista, please read Install.
Il. Updates & upgrades

If you want to upgrade your askiavista from version 5.1.6.x to the 5.2.4.0 version, please read upg/5.1-5.2.

If you want to update your askiavista 5.2.x to the latest build, please read upd/5.2.
11l Version history

If you want more info on specific features that each version can provide you with we invite you to browse our application's version history.
Attachments

« new.png (40.5 kB) - added by ben 2 days ago.

Download in other formats:
Plain Text

i trac

And how it'd be, aside from color-scheme:
Welcome to askiavista's Wiki

Hi, we've made this wiki for you!

We do our best ta keep it up to date as well as 100% accurate, but in case you do notice something please contact ben@askia.com!
I. Install

If you want to install askiavista, please read Install.

Il. Updates & upgrades

If you want to upgrade your askiavista from version 5.1.6.% to the 5.2.4.3 version, please read Upgrade 5.1.6.x to 5.2.4.x.
If you want to update your askiavista 5.2.x to the latest build, please read Update to 5.2.x.

Il FAQ

Got a gquestion? The answer just might be in our FAQ!

IV. Version history

For more info on features and differences between versions please consult our version history.

& new.png (117.7 KB} fif Benjamin Pollard Nelson, 16 January 2009 12:32 PM

Does your patch allow for this? Will it run on 0.8?
Thanks

#4 - 2009-01-28 17:32 - Christian Zuckschwerdt
- % Done changed from 0 to 30

Ben,

that's exactly my motivation. The patch provides that sidebar using a wiki page named 'Sidebar'. Did you try it? Perhaps the patch needs an update.
runs fine here and I'm still waiting for a general approval from the devs to make this a full-blown feature.

#5 - 2009-01-28 18:41 - Ben Blanco

Hi Chris,

Thanks for the feedback - we should be giving this a spin tomorrow ;)
#6 - 2009-02-06 17:07 - Ben Blanco

Hi Chris,

We put this in place, and Wow, what a night&day difference it's made for us. Thanks!
Ben

#7 - 2009-02-27 19:00 - Vianney Lecroart

Hi Chris,

Thanks for this patch, really useful, | added it on my redmine!

#8 - 2009-03-30 00:20 - Mischa The Evil

Christian Zuckschwerdt wrote:

...The patch provides that sidebar using a wiki page named 'Sidebar'. Did you try it? Perhaps the patch needs an update. It runs fine here and
I'm still waiting for a general approval from the devs to make this a full-blown feature...
This still works in the basics on the current trunk at r2641. One issue that comes up though are the section-links on headings which now points to the
incorrect pages...

#9 - 2009-03-30 00:44 - Christian Zuckschwerdt

One issue that comes up though are the section-links on headings which now points to the incorrect pages...

Can you provide an example? In case you refer to the automatic anchors/links on headings, you can not have headings with exactly the same name
in both content and sidebar.

#10 - 2009-03-30 01:24 - Mischa The Evil
Christian Zuckschwerdt wrote:
One issue that comes up though are the section-links on headings which now points to the incorrect pages...

Can you provide an example? In case you refer to the automatic anchors/links on headings, you can not have headings with exactly the same
name in both content and sidebar.

That's exactly what | meant... The automatic anchors/links are pointing to the current page which breaks them and as a side-effect of that duplicates
can occur (which will raise an error | guess).

#11 - 2009-03-30 01:37 - Christian Zuckschwerdt

Can you give a bit more detail? Say | put a "h3. Foobar" in the Sidebar. There will be an anchor #Foobar and a link to #Foobar on every page. No
problem there, or am | missing something?

If you then put the same name Say "h1. Foobar" on some page you are in trouble. But content authors will always need to be careful there. |.e. you
can't use "h1. Foobar" and say "h2. Foobar" on the same page anyhow.

#12 - 2009-03-30 04:12 - Mischa The Evil
Christian Zuckschwerdt wrote:
Can you give a bit more detail? Say | put a "h3. Foobar" in the Sidebar. There will be an anchor #Foobar and a link to #Foobar on every page.

No problem there, or am | missing something?

This is the thing / see as a problem: The anchor/link #Foobar in your example is pointing to a non-existing section on the current page if no such
heading is used in the current page...

#13 - 2009-03-30 14:44 - Christian Zuckschwerdt

The anchor/link #Foobar in your example is pointing to a non-existing section on the current page if no such heading is used in the current
page...

Let clear this up some. That automatic link is pointing to the that same automatic anchor. l.e. when you add a heading "Foobar" it gets an id of
"Foobar" serving as anchor for the link "#Foobar". It doesn't matter if this happens to be content or Sidebar. Did you experience otherwise? You can't
use automatic links in the Sidebar to point to some content section.

Maybe you are talking about some manual links? Can you provide an example?

#14 - 2009-03-30 16:13 - Mischa The Evil
Christian Zuckschwerdt wrote:
Mischa The Evil wrote:
The anchor/link #Foobar in your example is pointing to a non-existing section on the current page if no such heading is used in the current

page...

Let clear this up some. That automatic link is pointing to the that same automatic anchor. l.e. when you add a heading "Foobar" it gets an id of
"Foobar" serving as anchor for the link "#Foobar". It doesn't matter if this happens to be content or Sidebar. Did you experience otherwise?

It does matter IMHO since this creates non-existent (automatically generated) anchor-links in the sidebar when using a sidebar-page.

For example with a Sidebar-page like following
https://www.redmine.org/projects/redmine/repository/svn/revisions/2641

hl. Sidebar

h2. Testers

* [[Testl]]
* [[Test2]]
h2. Others
* [[Otherl]]
* [[Other2]]

my startpage (named Wiki) includes the Sidebar-page in the wiki-sidebar but this " partial " also includes automatically generated anchor-links on the
headings (Testers and Others) pointing to these same anchors though on the current startpage (Wiki) which doesn't include headings (thus anchors)
named Testers and Others.

Pff, seems difficult to explain but hope | made clear what | mean... :wink:

Christian Zuckschwerdt wrote:

You can't use automatic links in the Sidebar to point to some content section.

Agreed and acknowledged... Seems logical indeed ;-)

#15 - 2009-03-30 16:30 - Christian Zuckschwerdt

my startpage (named Wiki) includes the Sidebar-page in the wiki-sidebar but this " partial " also includes automatically generated anchor-links on
the headings (Testers and Others) pointing to these same anchors though on the current startpage (Wiki) which doesn't include headings (thus
anchors) named Testers and Others.

Ok, | see. But don't these automatic links point to just the headings in the Sidebar?

It seems you want the automatic links to point to content (which would be nice indeed).

Maybe the simple solution would be to remove automatic linking from Sidebar headings. It's just confusing and not that many people would want to
link to a sidebar section anyway.

TODO:
e remove automatic links from Sidebar headings

e change Sidebar heading styles to match the existing Redmine sidebar items
¢ Advise users to start with h3 in the Sidebar

#16 - 2009-03-30 16:57 - Christian Zuckschwerdt
TODO:

Here is an updated patch. The Sidebar css styles now match the original sidebar. It's intended for #2641.

#17 - 2009-03-30 17:00 - Christian Zuckschwerdt

Huh, where did the attachment go?

#18 - 2009-03-30 17:02 - Mischa The Evil

Christian Zuckschwerdt wrote:

Huh, where did the attachment go?

Hehe, | think it got lost due to our cuncurrent edit-actions | guess...
Christian Zuckschwerdt wrote:

...But don't these automatic links point to just the headings in the Sidebar?
https://www.redmine.org/issues/2641

AFAICT they don't... :-)

It seems you want the automatic links to point to content (which would be nice indeed).

| don't want and/or need it. | think it would make the implementation too difficult. | like your initial KISS-approach... :-)
Maybe the simple solution would be to remove automatic linking from Sidebar headings. It's just confusing and not that many people would want
to link to a sidebar section anyway.

+10... This seems the best solution IMHO too...

Thanks for supporting this patch...

Kind regards,

Mischa.

#19 - 2009-03-30 17:03 - Christian Zuckschwerdt
- File redmine-r2641-sidebar.patch added

Problem with Safari maybe?
#20 - 2009-06-15 05:23 - Andy Wiltshire

Is this still current?

| applied the latest patch to the latest version of redmine (15th June 09) and the sidebar intermittently disappears. As in, it 'kinda' works, then when
you reload or go to another page, it disappears etc.

Any ideas?

#21 - 2009-06-16 02:39 - Mischa The Evil

Andy Wiltshire wrote:
Is this still current?
| applied the latest patch to the latest version of redmine (15th June 09) and the sidebar intermittently disappears. As in, it 'kinda' works, then
when you reload or go to another page, it disappears etc.

Note sure about the current state of the patch but to be sure: have you actually created the Sidebar-wikipage as given in the instructions?:

The patch provides that sidebar using a wiki page named 'Sidebar'

Regards,
Mischa.

#22 - 2009-06-16 20:32 - Jens Goldhammer

+1 for integrating it into the trunk

#23 - 2009-07-06 22:56 - Mischa The Evil
Jens Goldhammer wrote:
+1 for integrating it into the trunk

This seems to be at least implemented as part of the Wiki Extensions plugin (thus you don't need to rely on core-modifications to get the desired
feature).

Regards,

Mischa.

#24 - 2010-04-11 14:54 - Jean-Philippe Lang
- Category set to Wiki
http://www.redmine.org/boards/3/topics/7130

- Status changed from New to Closed

Feature added in r3632.
